/*
	         Java RayTracer
	     By Dean Camera, 2008
	http://www.fourwalledcubicle.com
*/

import java.awt.image.*;
import java.io.*;
import javax.imageio.*;

public class TexImage implements ITexture
{
	private BufferedImage TextureImage;
	private int ImageWidth;
	private int ImageHeight;
	private float MaxU;
	private float MaxV;

	TexImage(String FileName) throws IOException
	{
		this(FileName, 1.0f, 1.0f);
	}
	
	TexImage(String FileName, float MaxU, float MaxV) throws IOException
	{
		TextureImage = ImageIO.read(new File(FileName));
	   
		ImageWidth  = (TextureImage.getWidth() - 1);
		ImageHeight = (TextureImage.getHeight() - 1);

		this.MaxU = MaxU;
		this.MaxV = MaxV;
	}
	
	public ColorVector GetUVMappedColor(float U, float V)
	{
		// Scale U and V values by the maximums, so that textures can be tiled a given number of times
		U *= MaxU;
		V *= MaxV;
		
		// Wrap the scaled values to get the point on the image
		U -= (int)U;
		V -= (int)V;
			
		int XCoord = (int)(ImageWidth  * U);
		int YCoord = (int)(ImageHeight * V);
		
		return new ColorVector(TextureImage.getRGB(XCoord, YCoord));
	}
}