/*
	         Java RayTracer
	     By Dean Camera, 2008
	http://www.fourwalledcubicle.com
*/

public class TexStripes implements ITexture
{
	private ColorVector TexColor1;
	private ColorVector TexColor2;
	private int         Stripes;
	private boolean     HorizontalStripes;

	public TexStripes(ColorVector TexColor1, ColorVector TexColor2, int Stripes, boolean HorizontalStripes)
	{
		this.TexColor1   = TexColor1;
		this.TexColor2   = TexColor2;
		this.Stripes     = Stripes;
		this.HorizontalStripes = HorizontalStripes;
	}

	public TexStripes(ColorVector TexColor1, int Stripes, boolean HorizontalStripes)
	{
		this(TexColor1, StdColors.GetNextColor(), Stripes, HorizontalStripes);
	}

	public TexStripes(int Stripes, boolean HorizontalStripes)
	{
		this(StdColors.GetNextColor(), StdColors.GetNextColor(), Stripes, HorizontalStripes);
	}

	public ColorVector GetUVMappedColor(float U, float V)
	{
		boolean Uon = (((int)(U * Stripes) & 1) == 1);
		boolean Von = (((int)(V * Stripes) & 1) == 1);

		if (U < 0)
		  Uon = !Uon;
		  
		if (V < 0)
		  Von = !Von;

		if ((Uon && !HorizontalStripes) || (Von && HorizontalStripes))
			return TexColor1;
		else
			return TexColor2;
	}
}